/* $Id: new.c,v 1.3 2003/09/28 15:16:15 mac Exp $
* give new passwd
*
* copyleft 2003 mac@research.co.jp
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "uauth.h"
#include <sys/time.h>

void
newpasswd(void)
{
	GDBM_FILE               dbf;
	FILE                   *fusb;
	char                    state[N_STATE];
	unsigned int            ibuf[N_CRYPT / sizeof(unsigned int) + 1];
	char                   *buf;
	datum                   duser, dpasswd;
	struct timeval          tv;
	unsigned int            seed, *p;
	int                     x, y;


	if ((dbf = gdbm_open(DBname, BUFSIZ, (GDBM_WRCREAT | GDBM_SYNC),
				0600, NULL)) == NULL) {
		fprintf(stderr, "%s: gdbm error at open %s to write\n\t%s\n",
			progname, DBname, gdbm_strerror(gdbm_errno));
		return;
	}

	duser.dsize = strlen(user);
	duser.dptr = user;

	buf = (char *) ibuf;
	gettimeofday(&tv, NULL);
	seed = *(unsigned int *) &tv;
	initstate(seed, state, N_STATE);
	strncpy(buf, user, N_USER);

	p = ibuf;

	while (p < &ibuf[N_CRYPT / sizeof(unsigned int)]) {
		*p++ = random();
	}
	gethostname(hostname, N_HOSTNAME);
	sprintf(name, "%s/%s", Mpoint, hostname);

	if (mount(authDEV, Mpoint, Mtype,
			(MS_MGC_VAL | MS_SYNCHRONOUS), NULL) != 0) {
		fprintf(stderr, "%s: mount error %s\n", progname, authDEV);
		exit(-1);
	}

	if ((fusb = fopen(name, "w")) == NULL) {
		fprintf(stderr, "%s: Can't open %s\n", progname, name);
		perror(NULL);
		umount(Mpoint);
		exit(-1);
	}
	x = fprintf(fusb, "%s\n", user);
	y = fwrite(buf, 1, N_CRYPT, fusb);
	fflush(fusb);
	fclose(fusb);
	umount(Mpoint);

	if ((x + y) != (duser.dsize + N_CRYPT + 1)) {
		fprintf(stderr, "%s: write error on %s\n", progname, name);
		return;
	};

	dpasswd.dsize = N_CRYPT;
	dpasswd.dptr = buf;
	gdbm_store(dbf, duser, dpasswd, GDBM_REPLACE);
	gdbm_close(dbf);

	return;
}
